using System;
using System.Runtime.InteropServices;

namespace CNet
{
    [System.Security.SuppressUnmanagedCodeSecurity]
    public static unsafe class SafeNativeMethods 
    {
        //******************************************************************************
        //* [ ComiNETSDKDef.h ]
        //* Header file for definitions of constants and data in CMNSDK library
        //* - Update Data: 2018/07/05
        //* - Provider: COMIZOA Co., Ltd.
        //* - Phone: +82-42-936-6500~6
        //* - Fax  : +82-42-936-6507
        //* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
        //'*******************************************************************************

        //*******************************************************************************
        public const int VERSION_STRING_LENGTH = 21 + 1;
        public const string VERSION_STRING = "C-NET Library 4.0";

        ///////////////////////////////////////////////////////////////////////
        public const int cmnERR_NONE = 0;
        public const int cmnERR_INVALID_PARAMETER = -190;
        public const int cmnERR_MEM_ALLOC_FAIL = -290;
        public const int cmnERR_GLOBAL_MEM_FAIL = -292;

        ///////////////////////////////////////////////////////////////////////
        public const int cmnTRUE = 1;
        public const int cmnFALSE = 0;

        ///////////////////////////////////////////////////////////////////////
        public const int cmnERR_GN_RELOAD_DEVICE_FAIL = -9000;
        public const int cmnERR_GN_LOAD_DEVICE_FAIL = -10000;
        public const int cmnERR_GN_UNLOAD_DEVICE_FAIL = -10001;
        public const int cmnERR_GET_SLAVE_INFO_FAIL = -10002;
        public const int cmnERR_GET_SLAVE_INFO_ALL_FAIL = -10003;
        public const int cmnERR_GET_GLOBAL_CHANNEL_MAP_FAIL = -10004;
        public const int cmnERR_GN_GET_GLOBAL_CHANNEL_MAP_FAIL = -10005;
        public const int cmnERR_GN_PUT_USER_CHANNEL_MAP_FAIL = -10006;
        public const int cmnERR_GN_DLG_SETUP_FAIL = -10007;
        public const int cmnERR_LOCAL_DI_GET_ONE_FAIL = -10008;
        public const int cmnERR_LOCAL_DI_GET_MULTI_FAIL = -10009;
        public const int cmnERR_LOCAL_DO_PUT_ONE_FAIL = -10010;
        public const int cmnERR_LOCAL_DO_PUT_MULTI_FAIL = -10011;
        public const int cmnERR_LOCAL_DO_GET_ONE_FAIL = -10012;
        public const int cmnERR_LOCAL_DO_GET_MULTI_FAIL = -10013;
        public const int cmnERR_DI_GET_ONE_FAIL = -10014;
        public const int cmnERR_DI_GET_MULTI_FAIL = -10015;
        public const int cmnERR_DO_PUT_ONE_FAIL = -10016;
        public const int cmnERR_DO_PUT_MULTI_FAIL = -10017;
        public const int cmnERR_DO_GET_ONE_FAIL = -10018;
        public const int cmnERR_DO_GET_MULTI_FAIL = -10019;
        public const int cmnERR_GN_START_RING_ALL_FAIL = -10020;
        public const int cmnERR_GN_START_RING_FAIL = -10021;
        public const int cmnERR_GN_RESET_RING_FAIL = -10022;
        public const int cmnERR_GN_STOP_RING_FAIL = -10023;
        public const int cmnERR_GN_RESET_DEVICE_FAIL = -10024;
        public const int cmnERR_GN_ISRESET_DEVICE_FAIL = -10025;
        public const int cmnERR_GN_GET_COM_STATUS_FAIL = -10026;
        public const int cmmERR_GN_GET_COM_SPEED_FAIL = -10027;
        public const int cmnERR_GN_SET_COM_SPEED = -10028;
        public const int cmnERR_GN_DLG_GET_LAST_MESSAGE_FAIL = -10029;
        public const int cmnERR_GN_DLG_GET_NO_MORE_MESSAGE_FAIL = -10030;
        public const int cmnERR_GN_DLG_GET_BUFFER_SMALL_FAIL = -10031;

        public const int cmnERR_GET_MASTER_INTERRUPT_STATUS = -10032;
        public const int cmnERR_GET_SLAVE_COM_ERROR         = -10033;
        public const int cmnERR_SET_SLAVE_COM_ERROR         = -10034;
        public const int cmnERR_SET_INPUT_INTERRUPT_ENABLE  = -10035;
        public const int cmnERR_GET_INPUT_INTERRUPT_STATUS  = -10036;
        public const int cmnERR_GN_GET_GLOBAL_CHANNEL_MAP_SLAVE_ZERO_FAIL = -10037;
        public const int cmnERR_GET_RING_TOTAL				=	-10038;
// 140619 YJB
// G9004 - AIO ߰ : TODO
        public const int cmnERR_AI_SET_VOLT_RANGE_MODE_FAIL =   -10039;
        public const int cmnERR_AI_GET_VOLT_RANGE_MODE_FAIL =   -10040;
        public const int cmnERR_AI_GET_DIGIT_RANGE_FAIL =   -10041;
        public const int cmnERR_AI_GET_DIGIT_FAIL       =   -10042;
        public const int cmnERR_AI_GET_VOLT_FAIL        =   -10043;
        public const int cmnERR_AI_GET_CURRENT_FAIL     =   -10044;
        public const int cmnERR_AO_SET_DIGIT_FAIL       =   -10045;
        public const int cmnERR_AO_SET_VOLT_FAIL        =   -10046;
        public const int cmnERR_AO_SET_CURRENT_FAIL     =   -10047;
// 140714 YJB
// G9004 - Serial ߰ : TODO
        public const int cmnERR_SER_OPEN_PORT_FAIL      =   -10048;
        public const int cmnERR_SER_CLOSE_PORT_FAIL     =   -10049;
        public const int cmnERR_SER_SET_TIME_OUT_FAIL   =	-10050;
        public const int cmnERR_SER_GET_TIME_OUT_FAIL	=	-10051;
        public const int cmnERR_SER_IS_DATA_READY_FAIL	=	-10052;
        public const int cmnERR_SER_GET_UNREAD_SIZE_FAIL=	-10053;
        public const int cmnERR_SER_READ_BYTES_FAIL		=	-10054;
        public const int cmnERR_SER_WRITE_BYTES_FAIL	=	-10055;
        public const int cmnERR_SER_RX_RESET_FAIL		=	-10056;
        public const int cmnERR_SER_TX_RESET_FAIL       =   -10057;

        ///////////////////////////////////////////////////////////////////////
        public const int cmnLOGIC_A = 0;
        public const int cmnLOGIC_B = 1;

        ///////////////////////////////////////////////////////////////////////

        // Device Information

        ///////////////////////////////////////////////////////////////////////
        public const int DI_00_DO_32C = 0x0;
        public const int DI_08_DO_08C = 0x1;
        public const int DI_16_DO_16C = 0x2;
        public const int DI_16_DO_OOH = 0x3;
        public const int DI_32_DO_00C = 0x4;
        public const int DI_08_DO_08H = DI_08_DO_08C;
        public const int DI_00_DO_16H = 0x5;
        public const int DI_00_DO_24C = 0x6;

        //////////////////////////////////////////////////////////////////////////
        // AIO Slave (G9004) ġ 
        //////////////////////////////////////////////////////////////////////////

        public const int DEV_DATA   = 0xB;
        public const int AI_08A	    = 0x11;
        public const int AO_04V     = 0x18;
        public const int AI_RTD	    = 0x20;
        public const int AI_TC      = 0x21;
        public const int SC04_I232  = 0x2E;
        public const int SC04_I485  = 0x2F;
        
        
        ///////////////////////////////////////////////////////////////////////
        // Communication Speed
        ///////////////////////////////////////////////////////////////////////

        public const int SPEED_1X = 0x0;
        //// 2.5 Mbps 
        public const int SPEED_2X = 0x1;
        //// 5 Mbps 
        public const int SPEED_3X = 0x2;
        //// 10Mbps 
        public const int SPEED_4X = 0x3;
        //// 20Mbps 

        ///////////////////////////////////////////////////////////////////////

        //// Communication Status

        ///////////////////////////////////////////////////////////////////////
        //public const int RING_DISCONNECTED = 0x0;
        //public const int RING_CONNECTED    = 0x1;
        //public const int SLAVE_ERROR       = 0x2;
        //public const int RING_STOP         = 0x3;

        //public const int RING_DISCONNECTED = 13;
        //public const int RING_CONNECTED = 12;
        //public const int SLAVE_ERROR = 3;
        //public const int RING_STOP = 2;

        public const int RING_DISCONNECTED  =   0x2000;
        public const int RING_CONNECTED     =   0x1000;
        public const int SLAVE_ERROR        =   0x8;
        public const int RING_STOP          =   0x4;

        //////////////////////////////////////////////////////////////////////////
        // Exchange Dio
        //////////////////////////////////////////////////////////////////////////
        public const int READ_EXCHANGE		= 0x0;
        public const int WRITE_EXCHANGE		= 0x1;
        public const int ALL_EXCHANGE		= 0x2;

        //////////////////////////////////////////////////////////////////////////
        // Analog Range
        //////////////////////////////////////////////////////////////////////////
        public const int AI_RANGE_MODE0		= 0x0;				// -10V ~ +10V
        public const int AI_RANGE_MODE1		= 0x1;				// -5V ~ +5V
        public const int AI_RANGE_MODE2		= 0x2;				// -2.5V ~ +2.5V
        public const int AI_RANGE_MODE3		= 0x3;				// 0V ~ +10V (0 ~ 20 mA)

        //////////////////////////////////////////////////////////////////////////
        // Serial Config
        //////////////////////////////////////////////////////////////////////////
        public const int SER_TYPE_232		= 0x0;
        public const int SER_TYPE_485		= 0x1;
        public const int SER_TYPE_422		= 0x2;

        public const int BR_075          = 0x0;
        public const int BR_110          = 0x1;
        //public const int BR_134_5      = 0x2;
        public const int BR_150          = 0x2;
        public const int BR_300          = 0x3;
        public const int BR_600          = 0x4;
        public const int BR_1200         = 0x5;
        public const int BR_1800         = 0x6;
        public const int BR_2400         = 0x7;
        public const int BR_4800         = 0x8;
        public const int BR_7200         = 0x9;
        public const int BR_9600         = 0xA;
        public const int BR_14400        = 0xB;
        public const int BR_19200        = 0xC;
        public const int BR_38400        = 0xD;
        public const int BR_56K          = 0xE;
        public const int BR_128K         = 0xF;
        public const int BR_115200       = 0x10;
        public const int BR_57600        = 0x11;

        public const int DATA_8				= 0x0;
        public const int DATA_9				= 0x1;

        public const int STOP_1				= 0x0;
        public const int STOP_0_5			= 0x1;
        public const int STOP_2				= 0x2;
        public const int STOP_1_5			= 0x3;

        public const int PAR_NONE			= 0x0;
        public const int PAR_ODD			= 0x1;
        public const int PAR_EVEN           = 0x2;


        ///////////////////////////////////////////////////////////////////////

        //// Debugging

        ///////////////////////////////////////////////////////////////////////
        public const int DEBUG_LEVEL_SUMMERY = 0;
        public const int DEBUG_LEVEL_DETAIL = 1;
        public const int DEBUG_LEVEL_DEBUG = 2;
        public const int DEBUG_LEVEL_ALL = 3;
        public const int DEBUG_DISABLE = 0;
        public const int DEBUG_ENABLE = 1;
        public const int DEBUG_OUT_WINDOW = 0;
        public const int DEBUG_OUT_LOCALFILE = 1;
        public const int DEBUG_OUT_CONSOLE = 2;
        public const int DEBUG_OUT_SOCKET = 3;
        public const int DEBUG_OUT_CALLBACK = 4;

        ///////////////////////////////////////////////////////////////////////

        ////  Master ġ  

        ///////////////////////////////////////////////////////////////////////
        [StructLayout(LayoutKind.Sequential)]
        struct TCNETMasterInfo {
            public ushort wSubSysID;
	        public uint nInstance;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
            public byte[] szDevName;
        };
        [StructLayout(LayoutKind.Sequential)]
        struct TCMNSlaveInfo
        {
	        public int nDevNumber;
	        public byte Use;
	        public byte DevType;
	        public byte Reserved;
        };

       [StructLayout(LayoutKind.Sequential)]
       struct TCNETInitData
        {
           public int nSlaveID;
           public int nSlaveType;
	       public int nSlaveData;
        };

        public const int MAX_SLAVE = 64;
        public const int MAX_RING = 2;

        //////////////////////////////////////////////////////////////////////////
        // 1   Slave IP   ü̴.
        //////////////////////////////////////////////////////////////////////////
        [StructLayout(LayoutKind.Sequential)]
        struct TCMNSlaveInfoEx
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 64)]
	        public TCMNSlaveInfo[] Dev;
        };

        [StructLayout(LayoutKind.Sequential)]
        public struct TCMNDevInfo
        {
            public int nTotalDevNumber;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public TCNETSingleSlaveInfo[] SlaveInfo; 
        }

        //////////////////////////////////////////////////////////////////////////
        // Serial Config Structure
        //////////////////////////////////////////////////////////////////////////

        [StructLayout(LayoutKind.Sequential)]
        public struct TCMNSerialInfo
        {
            public byte Reserved00;
            public byte ParityBit;
            public byte StopBit;
            public byte DataBit;
            public byte BaudRate;
            public byte SerType;
        }


        //////////////////////////////////////////////////////////////////////////
        //  Slave IP   ü̴.
        //////////////////////////////////////////////////////////////////////////

        [StructLayout(LayoutKind.Sequential)]
        public struct TCNETSingleSlaveInfo
        {
            public int nDevNumber;
            public byte nDevInfo;
        }

        [StructLayout(LayoutKind.Sequential)]
        struct TCNETMultiSlaveInfo
        {
	        public int nTotalDevNumber;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            TCNETSingleSlaveInfo[] SlaveInfo;
        };

        //////////////////////////////////////////////////////////////////////////

        //////////////////////////////////////////////////////////////////////////
        // User Mapped Channel  Global Channel  ϴ ü

        [StructLayout(LayoutKind.Sequential)]
        internal struct TPhysicalSlaveDevice
        {
            uint nMasterDevNumber;
            uint nSlaveIpNumber;
            ushort nDevUse;
            uint nRingNumber;
            uint nDeviceType;
            uint nDIChannel;
            uint nDOChannel;
            uint nDIRange;
            uint nDORange;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct TLogicalSlaveDevice
        {
            uint nMasterDevNumber;
            uint nSlaveIpNumber;
            ushort nDevUse;
            uint nRingNumber;
            uint nDeviceType;
            uint nDIChannel;
            uint nDOChannel;
            uint nDIRange;
            uint nDORange;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct TCMNHeaderInfo
        {
            uint nTotalSlaveDevice;
            uint nTotalDIChannels;
            uint nTotalDOChannels;
            uint nMagicNumber;
            uint nDate;
            uint nSize;
            uint UseTable;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct TCMNChannelMapInfo
        {
            TPhysicalSlaveDevice gDevice;
            TLogicalSlaveDevice uDevice;
        }








        ////////////////////////////////////////////////////////////////////
        // Device Load / Unload
        ////////////////////////////////////////////////////////////////////

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnLoadDevice")]
        internal static extern unsafe int cmnGnLoadDevice([MarshalAs(UnmanagedType.I4)]int IsResetDevice, [MarshalAs(UnmanagedType.I4)]ref int pnTotalMasterDevices);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnUnloadDevice")]
        internal static extern unsafe int cmnGnUnloadDevice();

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnReloadDevice")]
        internal static extern unsafe int cmnGnReloadDevice([MarshalAs(UnmanagedType.I4)]int IsResetDevice, [MarshalAs(UnmanagedType.I4)]ref int nTotalMasterDevices);

        ////////////////////////////////////////////////////////////////////
        // Basic Control
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnIsResetDevice")]
        internal static extern unsafe int cmnGnIsResetDevice([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int IsReset);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnResetDevice")]
        internal static extern unsafe int cmnGnResetDevice([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnSetSearchSpeicalDelay")]
        internal static extern unsafe int cmnGnSetSearchSpeicalDelay([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nDelay_us);

        ////////////////////////////////////////////////////////////////////
        // Debug Function
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnDlgSetup", CharSet = CharSet.Unicode, BestFitMapping = false)]
        internal static extern unsafe int cmnGnDlgSetup([MarshalAs(UnmanagedType.I1)]bool Enable, [MarshalAs(UnmanagedType.R8)]double nLevel, double nDebugType, [MarshalAs(UnmanagedType.I4)]int Handler, [MarshalAs(UnmanagedType.I4)]object lParam, [MarshalAs(UnmanagedType.LPStr)] ref string szDebugFileName);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnDlgGetLastMessage", CharSet = CharSet.Unicode, BestFitMapping = false)]
        internal static extern unsafe int cmnGnDlgGetLastMessage([MarshalAs(UnmanagedType.I4)]int nBufferSize, [MarshalAs(UnmanagedType.LPStr)] ref string szBuffer, [MarshalAs(UnmanagedType.I4)]ref int StoredMsg);

        ////////////////////////////////////////////////////////////////////
        // C-NET Communcation internal  (MASTER)
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDiSetInputLogic")]
        internal static extern unsafe int cmnLocalDiSetInputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int InputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDiGetInputLogic")]
        internal static extern unsafe int cmnLocalDiGetInputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int InputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDoSetOutputLogic")]
        internal static extern unsafe int cmnLocalDoSetOutputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int OutputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDoGetOutputLogic")]
        internal static extern unsafe int cmnLocalDoGetOutputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int OutputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDiGetOne")]
        internal static extern unsafe int cmnLocalDiGetOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int InputStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDiGetMulti")]
        internal static extern unsafe int cmnLocalDiGetMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int NumChannel, [MarshalAs(UnmanagedType.I4)]ref int InuptStates);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDoPutOne")]
        internal static extern unsafe int cmnLocalDoPutOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int OutState);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnLocalDoPutMulti")]
        internal static extern unsafe int cmnLocalDoPutMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int NumChannel, [MarshalAs(UnmanagedType.I4)]int OutStates);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnLocalDoGetOne")]
        internal static extern unsafe int cmnLocalDoGetOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int OutputStatus);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnLocalDoGetMulti")]
        internal static extern unsafe int cmnLocalDoGetMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int NumChannel, [MarshalAs(UnmanagedType.I4)]ref int OutStates);

        ////////////////////////////////////////////////////////////////////
        // C-NET Communication between slave and master  (SLAVE)
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiSetInputLogic")]
        internal static extern unsafe int cmnDiSetInputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int InputLogic);
        
        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiGetInputLogic")]
        internal static extern unsafe int cmnDiGetInputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int InputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoSetOutputLogic")]
        internal static extern unsafe int cmnDoSetOutputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int OutputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoGetOutputLogic")]
        internal static extern unsafe int cmnDoGetOutputLogic([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int OutputLogic);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiGetOne")]
        internal static extern unsafe int cmnDiGetOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int InputStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiGetMulti")]
        internal static extern unsafe int cmnDiGetMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int nChannels, [MarshalAs(UnmanagedType.U4)] ref uint InputStates);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoPutOne")]
        internal static extern unsafe int cmnDoPutOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int OutState);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoPutMulti")]
        internal static extern unsafe int cmnDoPutMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int numChannel, [MarshalAs(UnmanagedType.U4)] uint OutStates);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoGetOne")]
        internal static extern unsafe int cmnDoGetOne([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int OutputStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoGetMulti")]
        internal static extern unsafe int cmnDoGetMulti([MarshalAs(UnmanagedType.I4)]int IniChannel, [MarshalAs(UnmanagedType.I4)]int numChannel, [MarshalAs(UnmanagedType.U4)] ref uint OutStates);

        ////////////////////////////////////////////////////////////////////
        // C-NET Communication between slave and master  (SLAVE) (EX Functions)
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiGetOneEx")]
        internal static extern unsafe int cmnDiGetOneEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]int nChannelNo, [MarshalAs(UnmanagedType.I4)]ref int InputStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDiGetMultiEx")]
        internal static extern unsafe int cmnDiGetMultiEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]ref int InputStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoPutOneEx")]
        internal static extern unsafe int cmnDoPutOneEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]int nChannel, [MarshalAs(UnmanagedType.I4)]int OutState);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoPutMultiEx")]
        internal static extern unsafe int cmnDoPutMultiEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]int OutStates);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoGetOneEx")]
        internal static extern unsafe int cmnDoGetOneEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]int nChannelNo, [MarshalAs(UnmanagedType.I4)]ref int OutState);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnDoGetMultiEx")]
        internal static extern unsafe int cmnDoGetMultiEx([MarshalAs(UnmanagedType.I4)]int nMasterCardNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nDevIp, [MarshalAs(UnmanagedType.I4)]int nPortNo, [MarshalAs(UnmanagedType.I4)]ref int OutStates);

        ////////////////////////////////////////////////////////////////////
        // Communication Control
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnStartRingAll")]
        internal static extern unsafe int cmnGnStartRingAll();

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnStartRing")]
        internal static extern unsafe int cmnGnStartRing([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nSlaveIp);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnResetRing")]
        internal static extern unsafe int cmnGnResetRing([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnStopRing")]
        internal static extern unsafe int cmnGnStopRing([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetComStatus")]
        internal static extern unsafe int cmnGnGetComStatus([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int nStatus);

        ////////////////////////////////////////////////////////////////////
        // Communication Speed Control
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetComSpeed")]
        internal static extern unsafe int cmnGnGetComSpeed([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int pStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnSetComSpeed")]
        internal static extern unsafe int cmnGnSetComSpeed([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nStatus);

        ////////////////////////////////////////////////////////////////////
        // General Device Information Functions
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetMasterTotal")]
        internal static extern unsafe int cmnGnGetMasterTotal([MarshalAs(UnmanagedType.I4)]ref int pTotalDeviceNum);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetSlaveTotal")]
        internal static extern unsafe int cmnGnGetSlaveTotal([MarshalAs(UnmanagedType.I4)]ref int pTotalDeviceNum);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetDITotal")]
        internal static extern unsafe int cmnGnGetDITotal([MarshalAs(UnmanagedType.I4)]ref int pTotalDiChannelNum);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetDOTotal")]
        internal static extern unsafe int cmnGnGetDOTotal([MarshalAs(UnmanagedType.I4)]ref int pTotalDOChannelNum);

        // ش ̽    ȯѴ.
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetRingTotal")]
        internal static extern unsafe int cmnGnGetRingTotal([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]ref int pRingTotal);

        ////////////////////////////////////////////////////////////////////
        // Master Device Information Functions
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetMasterInfo")]
        internal static extern unsafe int cmnGnGetMasterInfo([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]ref int pDeviceId);

        ////////////////////////////////////////////////////////////////////
        // Slave Device Information Functions
        ////////////////////////////////////////////////////////////////////

        //[DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetSlaveInfo")]
        //internal static extern unsafe int cmnGnGetSlaveInfo([MarshalAs(UnmanagedType.I4)]int nDeviceNo, int nRingNo, int nDevIp, ref int pDeviceType, ref int pUse);

        //internal static extern unsafe int cmnGnGetSlaveInfoAll)([MarshalAs(UnmanagedType.I4)]int nDeviceNo, __out TCMNDevInfo * pDevInfo, [MarshalAs(UnmanagedType.I4)]ref int pRing0SlaveTotal, [MarshalAs(UnmanagedType.I4)]ref int pRing1SlaveTotal);
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetSlaveInfoAll")]
        internal static extern unsafe int cmnGnGetSlaveInfoAll([MarshalAs(UnmanagedType.I4)]int nDeviceNo, ref TCMNDevInfo TCMDevInfo, ref int pRing0SlaveTotal, ref int pRing1SlaveTotal);

        ////////////////////////////////////////////////////////////////////
        // Set/Get of Error Communication Slave Device Number
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetSlaveComError")]
        internal static extern unsafe int cmnGnGetSlaveComError([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int pStatus1, [MarshalAs(UnmanagedType.I4)]ref int pStatus2);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnClrSlaveComError")]
        internal static extern unsafe int cmnGnClrSlaveComError([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]int nStatus1, [MarshalAs(UnmanagedType.I4)]int nStatus2);

        ////////////////////////////////////////////////////////////////////
        // Interrupt Functions
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetMasterInterruptStatus")]
        internal static extern unsafe int cmnGnGetMasterInterruptStatus([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int pStatus);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnSetInputInterruptEnable")]
        internal static extern unsafe int cmnGnSetInputInterruptEnable([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int pStatus1, [MarshalAs(UnmanagedType.I4)]ref int pStatus2);

        [DllImport("CNETSDK.dll", EntryPoint ="cmnGnGetInputInterruptStatus")]
        internal static extern unsafe int cmnGnGetInputInterruptStatus([MarshalAs(UnmanagedType.I4)]int nDeviceNo, [MarshalAs(UnmanagedType.I4)]int nRingNo, [MarshalAs(UnmanagedType.I4)]ref int pStatus1, [MarshalAs(UnmanagedType.I4)]ref int pStatus2);

        ////////////////////////////////////////////////////////////////////
        // User Mapped Channel And Global Channel
        ////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetGlobalChannelMap", CharSet = CharSet.Unicode, BestFitMapping = false)]
        internal static extern unsafe int cmnGnGetGlobalChannelMap([MarshalAs(UnmanagedType.LPStr)] ref string szFileName);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnPutUserChannelMap", CharSet = CharSet.Unicode, BestFitMapping = false)]
        internal static extern unsafe int cmnGnPutUserChannelMap([MarshalAs(UnmanagedType.LPStr)] ref string szFileName);



        //////////////////////////////////////////////////////////////////////////
        // C-NET Analog In & Out Functions  (SLAVE)
        //////////////////////////////////////////////////////////////////////////


        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetAITotal")]
        internal static extern unsafe int cmnGnGetAITotal([MarshalAs(UnmanagedType.I4)]ref int pTotalAiChannelNum);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetAOTotal")]
        internal static extern unsafe int cmnGnGetAOTotal([MarshalAs(UnmanagedType.I4)]ref int pTotalAOChannelNum);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiSetVoltRangeMode")]
        internal static extern unsafe int cmnAiSetVoltRangeMode([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int RangeMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiGetVoltRangeMode")]
        internal static extern unsafe int cmnAiGetVoltRangeMode([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int RangeMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiGetDigitRange")]
        internal static extern unsafe int cmnAiGetDigitRange([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int DigitMin, [MarshalAs(UnmanagedType.I4)]ref int DigitMax);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiGetDigit")]
        internal static extern unsafe int cmnAiGetDigit([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int nDigit);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiGetVolt")]
        internal static extern unsafe int cmnAiGetVolt([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.R8)]ref double fVolt);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAiGetCurrent")]
        internal static extern unsafe int cmnAiGetCurrent([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.R8)]ref double fCurrent);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAoSetDigit")]
        internal static extern unsafe int cmnAoSetDigit([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int nDigit);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAoSetVolt")]
        internal static extern unsafe int cmnAoSetVolt([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.R8)]double fVolt);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnAoSetCurrent")]
        internal static extern unsafe int cmnAoSetCurrent([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.R8)]double fCurrent);

        //////////////////////////////////////////////////////////////////////////
        // C-NET Serial Functions  (SLAVE)
        //////////////////////////////////////////////////////////////////////////

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetSerTotal")]
        internal static extern unsafe int cmnGnGetSerTotal([MarshalAs(UnmanagedType.I4)]ref int pTotalSerChannelNum);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerOpenPort")]
        internal static extern unsafe int cmnSerOpenPort([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int nSerialType, [MarshalAs(UnmanagedType.I4)]int nBaudRate, [MarshalAs(UnmanagedType.I4)]int nDataBits, [MarshalAs(UnmanagedType.I4)]int nStopBits, [MarshalAs(UnmanagedType.I4)]int nParity);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerClosePort")]
        internal static extern unsafe int cmnSerClosePort([MarshalAs(UnmanagedType.I4)]int GlobalChNo);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerSetTimeout")]
        internal static extern unsafe int cmnSerSetTimeout([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int nTimeOut);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerGetTimeout")]
        internal static extern unsafe int cmnSerGetTimeout([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int nTimeOut);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerGetUnreadSize")]
        internal static extern unsafe int cmnSerGetUnreadSize([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int nUnreadSize);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerIsDataReady")]
        internal static extern unsafe int cmnSerIsDataReady([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]ref int IsReady);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerReadBytes")]
        internal static extern unsafe int cmnSerReadBytes([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int nLength, [MarshalAs(UnmanagedType.I1)]ref byte pBuffer);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerWriteBytes")]
        internal static extern unsafe int cmnSerWriteBytes([MarshalAs(UnmanagedType.I4)]int GlobalChNo, [MarshalAs(UnmanagedType.I4)]int nLength, [MarshalAs(UnmanagedType.I1)]ref byte pBuffer);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerRxReset")]
        internal static extern unsafe int cmnSerRxReset([MarshalAs(UnmanagedType.I4)]int GlobalChNo);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSerTxReset")]
        internal static extern unsafe int cmnSerTxReset([MarshalAs(UnmanagedType.I4)]int GlobalChNo);

        //////////////////////////////////////////////////////////////////////////
        // C-NET Motion Functions  (SLAVE)
        //////////////////////////////////////////////////////////////////////////
        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetMotionTotal")]
        internal static extern unsafe int cmnGnGetMotionTotal([MarshalAs(UnmanagedType.I4)]	ref int pTotalMotionChannelNum);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnSetServoOn")]
        internal static extern unsafe int cmnGnSetServoOn([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Enable);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetServoOn")]
        internal static extern unsafe int cmnGnGetServoOn([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int Enable);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnPulseAlarmRes")]
        internal static extern unsafe int cmnGnPulseAlarmRes([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int IsOnPulse, [MarshalAs(UnmanagedType.I4)]int dwDuration);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnSetAlarmRes")]
        internal static extern unsafe int cmnGnSetAlarmRes([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Enable);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnGnGetAlarmRes")]
        internal static extern unsafe int cmnGnGetAlarmRes([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int Enable);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetMioProperty")]
        internal static extern unsafe int cmnCfgSetMioProperty([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int PropId, [MarshalAs(UnmanagedType.I4)]int ProVal);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetMioProperty")]
        internal static extern unsafe int cmnCfgGetMioProperty([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int PropId, [MarshalAs(UnmanagedType.I4)]ref int ProVal);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetInMode")]
        internal static extern unsafe int cmnCfgSetInMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int InputMode, [MarshalAs(UnmanagedType.I4)]int IsInverse);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetInMode")]
        internal static extern unsafe int cmnCfgGetInMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int InputMode, [MarshalAs(UnmanagedType.I4)]ref int IsInverse);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetOutMode")]
        internal static extern unsafe int cmnCfgSetOutMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int OutputMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetOutMode")]
        internal static extern unsafe int cmnCfgGetOutMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int OutputMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetInOutRatio")]
        internal static extern unsafe int cmnCfgSetInOutRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double Ratio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetInOutRatio")]
        internal static extern unsafe int cmnCfgGetInOutRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double Ratio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetUnitDist")]
        internal static extern unsafe int cmnCfgSetUnitDist([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double UnitDist);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetUnitDist")]
        internal static extern unsafe int cmnCfgGetUnitDist([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double UnitDist);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetUnitSpeed")]
        internal static extern unsafe int cmnCfgSetUnitSpeed([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double UnitSpeed);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetUnitSpeed")]
        internal static extern unsafe int cmnCfgGetUnitSpeed([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double UnitSpeed);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetSpeedRange")]
        internal static extern unsafe int cmnCfgSetSpeedRange([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double MaxPPS);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetSpeedRange")]
        internal static extern unsafe int cmnCfgGetSpeedRange([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double MaxPPS, [MarshalAs(UnmanagedType.R8)]ref double MinPPS);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetSpeedPattern")]
        internal static extern unsafe int cmnCfgSetSpeedPattern([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int SpeedMode, [MarshalAs(UnmanagedType.R8)]double WorkSpeed, [MarshalAs(UnmanagedType.R8)]double Accel, [MarshalAs(UnmanagedType.R8)]double Decel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetSpeedPattern")]
        internal static extern unsafe int cmnCfgGetSpeedPattern([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int SpeedMode, [MarshalAs(UnmanagedType.R8)]ref double WorkSpeed, [MarshalAs(UnmanagedType.R8)]ref double Accel, [MarshalAs(UnmanagedType.R8)]ref double Decel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetSpeedPattern_T")]
        internal static extern unsafe int cmnCfgSetSpeedPattern_T([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int SpeedMode, [MarshalAs(UnmanagedType.R8)]double WorkSpeed, [MarshalAs(UnmanagedType.R8)]double AccelTime, [MarshalAs(UnmanagedType.R8)]double DecelTime);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetSpeedPattern_T")]
        internal static extern unsafe int cmnCfgGetSpeedPattern_T([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int SpeedMode, [MarshalAs(UnmanagedType.R8)]ref double WorkSpeed, [MarshalAs(UnmanagedType.R8)]ref double AccelTime, [MarshalAs(UnmanagedType.R8)]ref double DecelTime);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetMinAccTime")]
        internal static extern unsafe int cmnCfgSetMinAccTime([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double MinAccT, [MarshalAs(UnmanagedType.R8)]double MinDecT);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetMinAccTime")]
        internal static extern unsafe int cmnCfgGetMinAccTime([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double MinAccT, [MarshalAs(UnmanagedType.R8)]ref double MinDecT);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetSoftLimit")]
        internal static extern unsafe int cmnCfgSetSoftLimit([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Enable, [MarshalAs(UnmanagedType.R8)]double LimitN, [MarshalAs(UnmanagedType.R8)]double LimitP);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetSoftLimit")]
        internal static extern unsafe int cmnCfgGetSoftLimit([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int Enable, [MarshalAs(UnmanagedType.R8)]ref double LimitN, [MarshalAs(UnmanagedType.R8)]ref double LimitP);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetRingCntr")]
        internal static extern unsafe int cmnCfgSetRingCntr([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int TargCntr, [MarshalAs(UnmanagedType.I4)]int Enable, [MarshalAs(UnmanagedType.R8)]double CntMax);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetRingCntr")]
        internal static extern unsafe int cmnCfgGetRingCntr([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int TargCntr, [MarshalAs(UnmanagedType.I4)]ref int Enable, [MarshalAs(UnmanagedType.R8)]ref double CntMax);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgSetVelCorrRatio")]
        internal static extern unsafe int cmnCfgSetVelCorrRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double CorrRatio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnCfgGetVelCorrRatio")]
        internal static extern unsafe int cmnCfgGetVelCorrRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double CorrRatio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxSetSpeedRatio")]
        internal static extern unsafe int cmnSxSetSpeedRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int SpeedMode, [MarshalAs(UnmanagedType.R8)]double VelRatio, [MarshalAs(UnmanagedType.R8)]double AccRatio, [MarshalAs(UnmanagedType.R8)]double DecRatio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxGetSpeedRatio")]
        internal static extern unsafe int cmnSxGetSpeedRatio([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int SpeedMode, [MarshalAs(UnmanagedType.R8)]ref double VelRatio, [MarshalAs(UnmanagedType.R8)]ref double AccRatio, [MarshalAs(UnmanagedType.R8)]ref double DecRatio);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxMove")]
        internal static extern unsafe int cmnSxMove([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double Distance, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxMoveStart")]
        internal static extern unsafe int cmnSxMoveStart([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double Distance);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxMoveTo")]
        internal static extern unsafe int cmnSxMoveTo([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double Position, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxMoveToStart")]
        internal static extern unsafe int cmnSxMoveToStart([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double Position);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxVMoveStart")]
        internal static extern unsafe int cmnSxVMoveStart([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Dir);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxStop")]
        internal static extern unsafe int cmnSxStop([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int IsWaitComplete, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxStopEmg")]
        internal static extern unsafe int cmnSxStopEmg([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxIsDone")]
        internal static extern unsafe int cmnSxIsDone([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int IsDone);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxWaitDone")]
        internal static extern unsafe int cmnSxWaitDone([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxOptSetIniSpeed")]
        internal static extern unsafe int cmnSxOptSetIniSpeed([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double IniSpeed);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxOptGetIniSpeed")]
        internal static extern unsafe int cmnSxOptGetIniSpeed([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double IniSpeed);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxSetCorrection")]
        internal static extern unsafe int cmnSxSetCorrection([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int CorrMode, [MarshalAs(UnmanagedType.R8)]double CorrAmount, [MarshalAs(UnmanagedType.R8)]double CorrVel, [MarshalAs(UnmanagedType.I4)]int CntrMask);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxGetCorrection")]
        internal static extern unsafe int cmnSxGetCorrection([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int CorrMode, [MarshalAs(UnmanagedType.R8)]ref double CorrAmount, [MarshalAs(UnmanagedType.R8)]ref double CorrVel, [MarshalAs(UnmanagedType.I4)]ref int CntrMask);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxOptSetRdpOffset")]
        internal static extern unsafe int cmnSxOptSetRdpOffset([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]double OffsetDist);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnSxOptGetRdpOffset")]
        internal static extern unsafe int cmnSxOptGetRdpOffset([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.R8)]ref double OffsetDist);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnStSetCount")]
        internal static extern unsafe int cmnStSetCount([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Target, [MarshalAs(UnmanagedType.I4)]int Count);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnStGetCount")]
        internal static extern unsafe int cmnStGetCount([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Target, [MarshalAs(UnmanagedType.I4)]ref int Count);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnStGetSpeed")]
        internal static extern unsafe int cmnStGetSpeed([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Source, [MarshalAs(UnmanagedType.R8)]ref double Speed);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnStReadMotionState")]
        internal static extern unsafe int cmnStReadMotionState([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int MotStates);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnStReadMioState")]
        internal static extern unsafe int cmnStReadMioState([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int MioStates);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeSetConfig")]
        internal static extern unsafe int cmnHomeSetConfig([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int HomeMode, [MarshalAs(UnmanagedType.I4)]int EzCount, [MarshalAs(UnmanagedType.R8)]double EscDist, [MarshalAs(UnmanagedType.R8)]double Offset);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeGetConfig")]
        internal static extern unsafe int cmnHomeGetConfig([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int HomeMode, [MarshalAs(UnmanagedType.I4)]ref int EzCount, [MarshalAs(UnmanagedType.R8)]ref double EscDist, [MarshalAs(UnmanagedType.R8)]ref double Offset);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeSetPosClrMode")]
        internal static extern unsafe int cmnHomeSetPosClrMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int PosClrMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeGetPosClrMode")]
        internal static extern unsafe int cmnHomeGetPosClrMode([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int PosClrMode);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeSetSpeedPattern")]
        internal static extern unsafe int cmnHomeSetSpeedPattern([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int SpeedMode, [MarshalAs(UnmanagedType.R8)]double Vel, [MarshalAs(UnmanagedType.R8)]double Accel, [MarshalAs(UnmanagedType.R8)]double Decel, [MarshalAs(UnmanagedType.R8)]double RevVel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeGetSpeedPattern")]
        internal static extern unsafe int cmnHomeGetSpeedPattern([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int SpeedMode, [MarshalAs(UnmanagedType.R8)]ref double Vel, [MarshalAs(UnmanagedType.R8)]ref double Accel, [MarshalAs(UnmanagedType.R8)]ref double Decel, [MarshalAs(UnmanagedType.R8)]ref double RevVel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeSetSpeedPattern_T")]
        internal static extern unsafe int cmnHomeSetSpeedPattern_T([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int SpeedMode, [MarshalAs(UnmanagedType.R8)]double Vel, [MarshalAs(UnmanagedType.R8)]double AccelTime, [MarshalAs(UnmanagedType.R8)]double DecelTime, [MarshalAs(UnmanagedType.R8)]double RevVel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeGetSpeedPattern_T")]
        internal static extern unsafe int cmnHomeGetSpeedPattern_T([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]ref int SpeedMode, [MarshalAs(UnmanagedType.R8)]ref double Vel, [MarshalAs(UnmanagedType.R8)]ref double AccelTime, [MarshalAs(UnmanagedType.R8)]ref double DecelTime, [MarshalAs(UnmanagedType.R8)]ref double RevVel);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeMoveStart")]
        internal static extern unsafe int cmnHomeMoveStart([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Direction);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeMove")]
        internal static extern unsafe int cmnHomeMove([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int Direction, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeMoveAll")]
        internal static extern unsafe int cmnHomeMoveAll([MarshalAs(UnmanagedType.I4)]int NumAxes, [MarshalAs(UnmanagedType.I4)]ref int AxisList, [MarshalAs(UnmanagedType.I4)]ref int DirList, [MarshalAs(UnmanagedType.I4)]int IsBlocking);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeMoveAllStart")]
        internal static extern unsafe int cmnHomeMoveAllStart([MarshalAs(UnmanagedType.I4)]int NumAxes, [MarshalAs(UnmanagedType.I4)]ref int AxisList, [MarshalAs(UnmanagedType.I4)]ref int DirList);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeGetSuccess")]
        internal static extern unsafe int cmnHomeGetSuccess([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int *IsSuccess);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeSetSuccess")]
        internal static extern unsafe int cmnHomeSetSuccess([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int IsSuccess);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeIsBusy")]
        internal static extern unsafe int cmnHomeIsBusy([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int *IsBusy);

        [DllImport("CNETSDK.dll", EntryPoint = "cmnHomeWaitDone")]
        internal static extern unsafe int cmnHomeWaitDone([MarshalAs(UnmanagedType.I4)]int GlobalAxisNo, [MarshalAs(UnmanagedType.I4)]int IsBlocking);
    }
}

