/*******************************************************************************
* [ ComiNETSDK.cpp ]
* CPP file for definitions of constants and data in CNETSDK library
* - Update Data: 2018/12/06
* - Provider: COMIZOA Co., Ltd.
* - Phone: +82-42-936-6500~6
* - Fax  : +82-42-936-6507
* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
********************************************************************************/

#include "stdafx.h"

#if defined(__BCPLUSPLUS__)  // Borland C++ Builder specific
 #include <vcl.h>
 #pragma hdrstop
#endif

#include <windows.h>
#include <stdio.h>

#define _DLL_MAIN_CPP_
#include "CNETSDK.h"

#if defined(_WIN64)
#ifdef UNICODE
#define __DLL_FILE_FULL_PATH__ L"CNETSDK_x64.DLL"
#else
#define __DLL_FILE_FULL_PATH__ "CNETSDK_x64.DLL"
#endif
#else
#ifdef UNICODE
#define __DLL_FILE_FULL_PATH__ L"CNETSDK_x86.DLL"
#else
#define __DLL_FILE_FULL_PATH__ "CNETSDK_x86.DLL"
#endif
#endif

typedef struct _tagLIB_FUNCT {
	char *name;
	FARPROC* ptr;
}LIB_FUNCT;

static HINSTANCE hLibrary=NULL;

BOOL CNETLoadDll(void)
{
	LIB_FUNCT Func[] = {

		//////////////////////////////////////////////////////////////////////////
		// Device Load / Unload
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnLoadDevice", 	(FARPROC*)&cmnGnLoadDevice},
		{"cmnGnUnloadDevice", 	(FARPROC*)&cmnGnUnloadDevice},
		{"cmnGnReloadDevice",   (FARPROC*)&cmnGnReloadDevice},

		//////////////////////////////////////////////////////////////////////////
		// Debug Function
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnDlgSetup",		(FARPROC*)&cmnGnDlgSetup},
		{"cmnGnDlgGetLastMessage",	(FARPROC*)&cmnGnDlgGetLastMessage},

		//////////////////////////////////////////////////////////////////////////
		// Basic Control
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnResetDevice",(FARPROC*)&cmnGnResetDevice},
		{"cmnGnIsResetDevice",(FARPROC*)&cmnGnIsResetDevice},
		{"cmnGnSetSearchSpeicalDelay",(FARPROC*)&cmnGnSetSearchSpeicalDelay},

		//////////////////////////////////////////////////////////////////////////
		// Channel Input / Output Logic 
		//////////////////////////////////////////////////////////////////////////
		{"cmnLocalDiSetInputLogic", (FARPROC*)&cmnLocalDiSetInputLogic},
		{"cmnLocalDiGetInputLogic", (FARPROC*)&cmnLocalDiGetInputLogic},
		{"cmnLocalDoSetOutputLogic",(FARPROC*)&cmnLocalDoSetOutputLogic},
		{"cmnLocalDoGetOutputLogic",(FARPROC*)&cmnLocalDoGetOutputLogic},

		{"cmnDiSetInputLogic", (FARPROC*)&cmnDiSetInputLogic},
		{"cmnDiGetInputLogic", (FARPROC*)&cmnDiGetInputLogic},
		{"cmnDoSetOutputLogic",(FARPROC*)&cmnDoSetOutputLogic},
		{"cmnDoGetOutputLogic",(FARPROC*)&cmnDoGetOutputLogic},

		//////////////////////////////////////////////////////////////////////////
		// Channel Operation
		//////////////////////////////////////////////////////////////////////////
		{"cmnLocalDiGetOne", (FARPROC*)&cmnLocalDiGetOne},
		{"cmnLocalDiGetMulti", (FARPROC*)&cmnLocalDiGetMulti},
		{"cmnLocalDoPutOne", (FARPROC *)&cmnLocalDoPutOne},
		{"cmnLocalDoPutMulti", (FARPROC*) &cmnLocalDoPutMulti},
		{"cmnLocalDoGetOne", (FARPROC *) &cmnLocalDoGetOne},
		{"cmnLocalDoGetMulti", (FARPROC*) &cmnLocalDoGetMulti},

		{"cmnDiGetOne", (FARPROC*)&cmnDiGetOne},
		{"cmnDiGetMulti", (FARPROC*)&cmnDiGetMulti},
		{"cmnDoPutOne", (FARPROC*)&cmnDoPutOne},
		{"cmnDoPutMulti",(FARPROC*)&cmnDoPutMulti},
		{"cmnDoGetOne",(FARPROC*)&cmnDoGetOne},
		{"cmnDoGetMulti",(FARPROC*)&cmnDoGetMulti},

		{"cmnDiGetOneEx", (FARPROC*)&cmnDiGetOneEx},
		{"cmnDiGetMultiEx", (FARPROC*)&cmnDiGetMultiEx},
		{"cmnDoPutOneEx", (FARPROC*)&cmnDoPutOneEx},
		{"cmnDoPutMultiEx",(FARPROC*)&cmnDoPutMultiEx},
		{"cmnDoGetOneEx",(FARPROC*)&cmnDoGetOneEx},
		{"cmnDoGetMultiEx",(FARPROC*)&cmnDoGetMultiEx},

		{"cmnDioExchange_Scan", (FARPROC*)&cmnDioExchange_Scan},
		{"cmnDioExchange_Run", (FARPROC*)&cmnDioExchange_Run},
		
		//////////////////////////////////////////////////////////////////////////
		// General Device Information Functions
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetMasterTotal",(FARPROC*)&cmnGnGetMasterTotal},
		{"cmnGnGetSlaveTotal",(FARPROC*)&cmnGnGetSlaveTotal},
		{"cmnGnGetDITotal",(FARPROC*)&cmnGnGetDITotal},
		{"cmnGnGetDOTotal",(FARPROC*)&cmnGnGetDOTotal},
		{"cmnGnGetRingTotal",(FARPROC*)&cmnGnGetRingTotal},

		//////////////////////////////////////////////////////////////////////////
		// Master Information 
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetMasterInfo",(FARPROC*)&cmnGnGetMasterInfo},

		//////////////////////////////////////////////////////////////////////////
		// Slave Information
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetSlaveInfoAll",(FARPROC*)&cmnGnGetSlaveInfoAll},

		//////////////////////////////////////////////////////////////////////////
		// Communication Control
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetComStatus",               (FARPROC*)&cmnGnGetComStatus},
		{"cmnGnStartRingAll",               (FARPROC*)&cmnGnStartRingAll},
		{"cmnGnStartRing",                  (FARPROC*)&cmnGnStartRing},
		{"cmnGnResetRing",                  (FARPROC*)&cmnGnResetRing},
		{"cmnGnStopRing",                   (FARPROC*)&cmnGnStopRing},

		//////////////////////////////////////////////////////////////////////////
		// Communication Speed Control
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetComSpeed",                (FARPROC*)&cmnGnGetComSpeed},
		{"cmnGnSetComSpeed",                (FARPROC*)&cmnGnSetComSpeed},

		//////////////////////////////////////////////////////////////////////////
		// User Mapped Channel And Global Channel
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetGlobalChannelMap",        (FARPROC*)&cmnGnGetGlobalChannelMap},
		{"cmnGnPutUserChannelMap",          (FARPROC*)&cmnGnPutUserChannelMap},

		//////////////////////////////////////////////////////////////////////////
		// Interrupt Functions
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetMasterInterruptStatus",   (FARPROC*)&cmnGnGetMasterInterruptStatus},
		{"cmnGnSetInputInterruptEnable",    (FARPROC*)&cmnGnSetInputInterruptEnable},
		{"cmnGnGetInputInterruptStatus",    (FARPROC*)&cmnGnGetInputInterruptStatus},


		//////////////////////////////////////////////////////////////////////////
		// Slave Communication Error
		//////////////////////////////////////////////////////////////////////////
		{"cmnGnGetSlaveComError",           (FARPROC*)&cmnGnGetSlaveComError},
		{"cmnGnClrSlaveComError",           (FARPROC*)&cmnGnClrSlaveComError},

		{"cmnGnGetAITotal",					(FARPROC*)&cmnGnGetAITotal},
		{"cmnGnGetAOTotal",					(FARPROC*)&cmnGnGetAOTotal},

		{"cmnAiSetVoltRangeMode",			(FARPROC*)&cmnAiSetVoltRangeMode},
		{"cmnAiGetVoltRangeMode",			(FARPROC*)&cmnAiGetVoltRangeMode},
		{"cmnAiGetDigitRange",				(FARPROC*)&cmnAiGetDigitRange},

		{"cmnAiGetDigit",					(FARPROC*)&cmnAiGetDigit},
		{"cmnAiGetVolt",					(FARPROC*)&cmnAiGetVolt},
		{"cmnAiGetCurrent",					(FARPROC*)&cmnAiGetCurrent},

		{"cmnAoSetDigit",					(FARPROC*)&cmnAoSetDigit},
		{"cmnAoSetVolt",					(FARPROC*)&cmnAoSetVolt},
		{"cmnAoSetCurrent",					(FARPROC*)&cmnAoSetCurrent},
		{"cmnGnSlaveConfig",				(FARPROC*)&cmnGnSlaveConfig},
		
		//////////////////////////////////////////////////////////////////////////
		// Serial Functions
		//////////////////////////////////////////////////////////////////////////

		{"cmnGnGetSerTotal",				(FARPROC*)&cmnGnGetSerTotal},
		{"cmnSerOpenPort",					(FARPROC*)&cmnSerOpenPort},
		{"cmnSerClosePort",					(FARPROC*)&cmnSerClosePort},
		{"cmnSerSetTimeout",				(FARPROC*)&cmnSerSetTimeout},
		{"cmnSerGetTimeout",				(FARPROC*)&cmnSerGetTimeout},
		{"cmnSerGetUnreadSize",				(FARPROC*)&cmnSerGetUnreadSize},
		{"cmnSerIsDataReady",				(FARPROC*)&cmnSerIsDataReady},
		{"cmnSerReadBytes",					(FARPROC*)&cmnSerReadBytes},
		{"cmnSerWriteBytes",				(FARPROC*)&cmnSerWriteBytes},
		{"cmnSerRxReset",					(FARPROC*)&cmnSerRxReset},
		{"cmnSerTxReset",					(FARPROC*)&cmnSerTxReset},
		
		
		//////////////////////////////////////////////////////////////////////////
		// Motion Functions
		//////////////////////////////////////////////////////////////////////////

		{"cmnGnGetMotionTotal",				(FARPROC*)&cmnGnGetMotionTotal},
		{"cmnGnSetServoOn",					(FARPROC*)&cmnGnSetServoOn},
		{"cmnGnGetServoOn",					(FARPROC*)&cmnGnGetServoOn},
		{"cmnGnPulseAlarmRes",				(FARPROC*)&cmnGnPulseAlarmRes},
		{"cmnGnSetAlarmRes",				(FARPROC*)&cmnGnSetAlarmRes},
		{"cmnGnGetAlarmRes",				(FARPROC*)&cmnGnGetAlarmRes},
		{"cmnCfgSetMioProperty",			(FARPROC*)&cmnCfgSetMioProperty},
		{"cmnCfgGetMioProperty",			(FARPROC*)&cmnCfgGetMioProperty},
		{"cmnCfgSetInMode",					(FARPROC*)&cmnCfgSetInMode},
		{"cmnCfgGetInMode",					(FARPROC*)&cmnCfgGetInMode},
		{"cmnCfgSetOutMode",				(FARPROC*)&cmnCfgSetOutMode},
		{"cmnCfgGetOutMode",				(FARPROC*)&cmnCfgGetOutMode},
		{"cmnCfgSetInOutRatio",				(FARPROC*)&cmnCfgSetInOutRatio},
		{"cmnCfgGetInOutRatio",				(FARPROC*)&cmnCfgGetInOutRatio},
		{"cmnCfgSetUnitDist",				(FARPROC*)&cmnCfgSetUnitDist},
		{"cmnCfgGetUnitDist",				(FARPROC*)&cmnCfgGetUnitDist},
		{"cmnCfgSetUnitSpeed",				(FARPROC*)&cmnCfgSetUnitSpeed},
		{"cmnCfgGetUnitSpeed",				(FARPROC*)&cmnCfgGetUnitSpeed},
		{"cmnCfgSetSpeedRange",				(FARPROC*)&cmnCfgSetSpeedRange},
		{"cmnCfgGetSpeedRange",				(FARPROC*)&cmnCfgGetSpeedRange},
		{"cmnCfgSetSpeedPattern",			(FARPROC*)&cmnCfgSetSpeedPattern},
		{"cmnCfgGetSpeedPattern",			(FARPROC*)&cmnCfgGetSpeedPattern},
		{"cmnCfgSetSpeedPattern_T",			(FARPROC*)&cmnCfgSetSpeedPattern_T},
		{"cmnCfgGetSpeedPattern_T",			(FARPROC*)&cmnCfgGetSpeedPattern_T},
		{"cmnCfgSetMinAccTime",				(FARPROC*)&cmnCfgSetMinAccTime},
		{"cmnCfgGetMinAccTime",				(FARPROC*)&cmnCfgGetMinAccTime},
		{"cmnCfgSetSoftLimit",				(FARPROC*)&cmnCfgSetSoftLimit},
		{"cmnCfgGetSoftLimit",				(FARPROC*)&cmnCfgGetSoftLimit},
		{"cmnCfgSetRingCntr",				(FARPROC*)&cmnCfgSetRingCntr},
		{"cmnCfgGetRingCntr",				(FARPROC*)&cmnCfgGetRingCntr},
		{"cmnCfgSetVelCorrRatio",			(FARPROC*)&cmnCfgSetVelCorrRatio},
		{"cmnCfgGetVelCorrRatio",			(FARPROC*)&cmnCfgGetVelCorrRatio},
		{"cmnSxSetSpeedRatio",				(FARPROC*)&cmnSxSetSpeedRatio},
		{"cmnSxGetSpeedRatio",				(FARPROC*)&cmnSxGetSpeedRatio},
		{"cmnSxMove",						(FARPROC*)&cmnSxMove},
		{"cmnSxMoveStart",					(FARPROC*)&cmnSxMoveStart},
		{"cmnSxMoveTo",						(FARPROC*)&cmnSxMoveTo},
		{"cmnSxMoveToStart",				(FARPROC*)&cmnSxMoveToStart},
		{"cmnSxVMoveStart",					(FARPROC*)&cmnSxVMoveStart},
		{"cmnSxStop",						(FARPROC*)&cmnSxStop},
		{"cmnSxStopEmg",					(FARPROC*)&cmnSxStopEmg},
		{"cmnSxIsDone",						(FARPROC*)&cmnSxIsDone},
		{"cmnSxWaitDone",					(FARPROC*)&cmnSxWaitDone},
		{"cmnSxOptSetIniSpeed",				(FARPROC*)&cmnSxOptSetIniSpeed},
		{"cmnSxOptGetIniSpeed",				(FARPROC*)&cmnSxOptGetIniSpeed},
		{"cmnSxSetCorrection",				(FARPROC*)&cmnSxSetCorrection},
		{"cmnSxGetCorrection",				(FARPROC*)&cmnSxGetCorrection},
		{"cmnSxOptSetRdpOffset",			(FARPROC*)&cmnSxOptSetRdpOffset},
		{"cmnSxOptGetRdpOffset",			(FARPROC*)&cmnSxOptGetRdpOffset},
		{"cmnStSetCount",					(FARPROC*)&cmnStSetCount},
		{"cmnStGetCount",					(FARPROC*)&cmnStGetCount},
		{"cmnStGetSpeed",					(FARPROC*)&cmnStGetSpeed},
		{"cmnStReadMotionState",			(FARPROC*)&cmnStReadMotionState},
		{"cmnStReadMioState",				(FARPROC*)&cmnStReadMioState},
		{"cmnHomeGetConfig",				(FARPROC*)&cmnHomeGetConfig},
		{"cmnHomeGetPosClrMode",			(FARPROC*)&cmnHomeGetPosClrMode},
		{"cmnHomeGetSpeedPattern",			(FARPROC*)&cmnHomeGetSpeedPattern},
		{"cmnHomeGetSpeedPattern_T",		(FARPROC*)&cmnHomeGetSpeedPattern_T},
		{"cmnHomeGetSuccess",				(FARPROC*)&cmnHomeGetSuccess},
		{"cmnHomeIsBusy",					(FARPROC*)&cmnHomeIsBusy},
		{"cmnHomeMove",						(FARPROC*)&cmnHomeMove},
		{"cmnHomeMoveAll",					(FARPROC*)&cmnHomeMoveAll},
		{"cmnHomeMoveAllStart",				(FARPROC*)&cmnHomeMoveAllStart},
		{"cmnHomeMoveStart",				(FARPROC*)&cmnHomeMoveStart},
		{"cmnHomeSetConfig",				(FARPROC*)&cmnHomeSetConfig},
		{"cmnHomeSetPosClrMode",			(FARPROC*)&cmnHomeSetPosClrMode},
		{"cmnHomeSetSpeedPattern",			(FARPROC*)&cmnHomeSetSpeedPattern},
		{"cmnHomeSetSpeedPattern_T",		(FARPROC*)&cmnHomeSetSpeedPattern_T},
		{"cmnHomeSetSuccess",				(FARPROC*)&cmnHomeSetSuccess},
		{"cmnHomeWaitDone",					(FARPROC*)&cmnHomeWaitDone},

		{NULL, NULL}
	};

	LIB_FUNCT *f;

	if((hLibrary = LoadLibrary (__DLL_FILE_FULL_PATH__)) == NULL)
		return FALSE;

	f = &Func[0];
	while(f->ptr != NULL)
	{
		*(f->ptr) = GetProcAddress ((HMODULE)hLibrary, f->name);
		if(*(f->ptr) == NULL){
			OutputDebugString(_T("The ComiNETSDK.DLL load has been failed."));
		}
		f++;
	}
	return TRUE;
}

void CNETUnloadDll(void)
{
	if(hLibrary){
		FreeLibrary(hLibrary);
		hLibrary = NULL;
	}
}

