/*******************************************************************************
* [ ComiNETSDK.h ]
* Header file for definitions of constants and data in CNETSDK library
* - Update Data: 2018/12/06
* - Provider: COMIZOA Co., Ltd.
* - Phone: +82-42-936-6500~6
* - Fax  : +82-42-936-6507
* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
********************************************************************************/

#ifndef __COMINET_SDK_H__
#define __COMINET_SDK_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CNETSDKDef.h"

#if !defined(__in)
#define __in
#endif

#if !defined(__out)
#define __out
#endif

#if !defined(__inout)
#define __inout
#endif

#ifdef __cplusplus
extern "C"{
#endif

#ifdef _DLL_MAIN_CPP_
	#define EXTERN 
#else 
	#define EXTERN extern
#endif

//////////////////////////////////////////////////////////////////////////
// Debug Handler Function Definition
//////////////////////////////////////////////////////////////////////////
typedef void (WINAPI *TDebugHandler) (LPVOID);

//////////////////////////////////////////////////////////////////////////
// External Functions for DLL(Dynamic Link Library)
//////////////////////////////////////////////////////////////////////////
BOOL CNETLoadDll();
VOID CNETUnloadDll();

//////////////////////////////////////////////////////////////////////////
// Device Load / Unload
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnLoadDevice)	 (LONG IsResetDevice, PLONG nTotalMasterDevices);
EXTERN VOID (WINAPI *cmnGnUnloadDevice) ();
EXTERN LONG (WINAPI *cmnGnReloadDevice) (LONG IsResetDevice, PLONG nTotalMasterDevices);

//////////////////////////////////////////////////////////////////////////
// Basic Control
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnIsResetDevice) (__in LONG nDeviceNo, __in LONG nRingNo,__out PLONG IsReset);
EXTERN LONG (WINAPI *cmnGnResetDevice)	  (__in LONG nDeviceNo, __in LONG nRingNo);
EXTERN LONG (WINAPI *cmnGnSetSearchSpeicalDelay) (__in LONG nDeviceNo, __in LONG nDelay_us);

//////////////////////////////////////////////////////////////////////////
// Debug Function
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnDlgSetup)	      (__in BOOL IsEnable,    __out DWORD nLevel,   __in DWORD nDebugType, __in HANDLE Handler, __in LPVOID lParam, __in PCHAR szDebugFileName);	
EXTERN LONG (WINAPI *cmnGnDlgGetLastMessage) (__in LONG nBufferSize, __out PCHAR szBuffer, __out PLONG StoredMsg);

//////////////////////////////////////////////////////////////////////////
// C-NET Communcation internal  (MASTER)
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnLocalDiSetInputLogic)	(__in LONG GlobalChNo, __in LONG InputLogic);
EXTERN LONG (WINAPI *cmnLocalDiGetInputLogic)	(__in LONG GlobalChNo, __out PLONG InputLogic);
EXTERN LONG (WINAPI *cmnLocalDoSetOutputLogic)	(__in LONG GlobalChNo, __in LONG OutputLogic);
EXTERN LONG (WINAPI *cmnLocalDoGetOutputLogic)	(__in LONG GlobalChNo, __in PLONG OutputLogic);

EXTERN LONG (WINAPI *cmnLocalDiGetOne)		(__in LONG GlobalChNo,__out PLONG InputStatus /* T or F */);
EXTERN LONG (WINAPI *cmnLocalDiGetMulti)	(__in LONG IniChannel, __in LONG  NumChannel, __out PLONG InuptStates /* Local Input 8ch */);
EXTERN LONG (WINAPI *cmnLocalDoPutOne)		(__in LONG GlobalChNo,__out LONG  OutState /* T or F */);
EXTERN LONG (WINAPI *cmnLocalDoPutMulti)	(__in LONG IniChannel, __in LONG  NumChannel, __out LONG OutStates /* 0xffff */);
EXTERN LONG (WINAPI *cmnLocalDoGetOne)		(__in LONG GlobalChNo,__out PLONG OutputStatus /* T or F */);
EXTERN LONG (WINAPI *cmnLocalDoGetMulti)	(__in LONG IniChannel, __in LONG  NumChannel, __out PLONG OutStates /* 0xffff */);

//////////////////////////////////////////////////////////////////////////
// C-NET Communication between slave and master  (SLAVE)
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnDiSetInputLogic)	(__in LONG GlobalChNo, __in LONG InputLogic);
EXTERN LONG (WINAPI *cmnDiGetInputLogic)	(__in LONG GlobalChNo, __in PLONG InputLogic);
EXTERN LONG (WINAPI *cmnDoSetOutputLogic)	(__in LONG GlobalChNo, __in LONG OutputLogic);
EXTERN LONG (WINAPI *cmnDoGetOutputLogic)	(__in LONG GlobalChNo, __in PLONG OutputLogic);

EXTERN LONG (WINAPI *cmnDiGetOne)	(__in LONG GlobalChNo,  __out PLONG InputStatus /* T or F */);
EXTERN LONG (WINAPI *cmnDiGetMulti)	(__in LONG IniChannel,  __in  LONG  nChannels,   __out PLONG InputStates /* 0xffff */ );
EXTERN LONG (WINAPI *cmnDoPutOne)	(__in LONG GlobalChNo,  __in  LONG  OutState  /* T or F */);
EXTERN LONG (WINAPI *cmnDoPutMulti)	(__in LONG IniChannel,  __in  LONG  nChannels , __in  LONG  OutStates  /* 0xffff */ );
EXTERN LONG (WINAPI *cmnDoGetOne)	(__in LONG GlobalChNo,  __out PLONG OutputStatus/* T or F */);
EXTERN LONG (WINAPI *cmnDoGetMulti)	(__in LONG IniChannel,  __in  LONG  nChannels,  __out PLONG OutStates  /* 0xffff */);

//////////////////////////////////////////////////////////////////////////
// C-NET Communication between slave and master  (SLAVE) (EX Functions)
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnDiGetOneEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __in LONG nChannelNo, __out PLONG InputStatus);
EXTERN LONG (WINAPI *cmnDiGetMultiEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __out PLONG InputStatus);
EXTERN LONG (WINAPI *cmnDoPutOneEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __in LONG nChannel, __in LONG OutState);
EXTERN LONG (WINAPI *cmnDoPutMultiEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __out LONG OutStates);
EXTERN LONG (WINAPI *cmnDoGetOneEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __in LONG nChannelNo, __out PLONG OutState);
EXTERN LONG (WINAPI *cmnDoGetMultiEx)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nDevIp, __in LONG nPortNo, __out PLONG OutStates);

EXTERN LONG (WINAPI *cmnDioExchange_Scan)  (__in LONG nMasterCardNo, __in LONG nRingNo, __inout  TCMNSlaveInfoEx * pSlaveInfoEx, __out PLONG pSlaveCnt);
EXTERN LONG (WINAPI *cmnDioExchange_Run)	(__in LONG nMasterCardNo, __in LONG nRingNo, __in LONG nExchangeMode, __inout  TCMNFastIo * fastIo);

//////////////////////////////////////////////////////////////////////////
// Communication Control
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnStartRingAll) ();
EXTERN LONG (WINAPI *cmnGnStartRing)	 (__in LONG nDeviceNo, __in LONG nRingNo, __in LONG nSlaveIp);
EXTERN LONG (WINAPI *cmnGnResetRing)	 (__in LONG nDeviceNo, __in LONG nRingNo);
EXTERN LONG (WINAPI *cmnGnStopRing)	 (__in LONG nDeviceNo, __in LONG nRingNo);
EXTERN LONG (WINAPI *cmnGnGetComStatus) (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG nStatus);

//////////////////////////////////////////////////////////////////////////
// Communication Speed Control
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetComSpeed) (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG pStatus);
EXTERN LONG (WINAPI *cmnGnSetComSpeed) (__in LONG nDeviceNo, __in LONG nRingNo, __in LONG nStatus);

//////////////////////////////////////////////////////////////////////////
// General Device Information Functions
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetMasterTotal)	  (__out PLONG pTotalDeviceNum);
EXTERN LONG (WINAPI *cmnGnGetSlaveTotal)	  (__out PLONG pTotalDeviceNum);
EXTERN LONG (WINAPI *cmnGnGetDITotal)		  (__out PLONG pTotalDiChannelNum);
EXTERN LONG (WINAPI *cmnGnGetDOTotal)		  (__out PLONG pTotalDOChannelNum);

// ش ̽    ȯѴ.
EXTERN LONG (WINAPI *cmnGnGetRingTotal)      (__in LONG nDeviceNo, __out PLONG pRingTotal);

//////////////////////////////////////////////////////////////////////////
// Master Device Information Functions
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetMasterInfo) (__in LONG nDeviceNo, __out PLONG pDeviceId);

//////////////////////////////////////////////////////////////////////////
// Slave Device Information Functions
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetSlaveInfoAll)(__in LONG nDeviceNo, __out TCMNDevInfo * pDevInfo, __out PLONG pRing0SlaveTotal, __out PLONG pRing1SlaveTotal);

//////////////////////////////////////////////////////////////////////////
// Set/Get of Error Communication Slave Device Number
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetSlaveComError)            (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG pStatus1, __out PLONG pStatus2);
EXTERN LONG (WINAPI *cmnGnClrSlaveComError)            (__in LONG nDeviceNo, __in LONG nRingNo, __in LONG nStatus1, __in LONG nStatus2);

//////////////////////////////////////////////////////////////////////////
// Interrupt Functions
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetMasterInterruptStatus)    (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG pStatus);
EXTERN LONG (WINAPI *cmnGnSetInputInterruptEnable)     (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG pStatus1, __out PLONG pStatus2);
EXTERN LONG (WINAPI *cmnGnGetInputInterruptStatus)     (__in LONG nDeviceNo, __in LONG nRingNo, __out PLONG pStatus1, __out PLONG pStatus2);

//////////////////////////////////////////////////////////////////////////
// User Mapped Channel And Global Channel
//////////////////////////////////////////////////////////////////////////
EXTERN LONG (WINAPI *cmnGnGetGlobalChannelMap) (__in PCHAR szFileName);
EXTERN LONG (WINAPI *cmnGnPutUserChannelMap) (__in PCHAR szFileName);
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// C-NET Analog In & Out Functions  (SLAVE)
//////////////////////////////////////////////////////////////////////////

EXTERN LONG (WINAPI *cmnGnGetAITotal)		  (__out PLONG pTotalAiChannelNum);
EXTERN LONG (WINAPI *cmnGnGetAOTotal)		  (__out PLONG pTotalAOChannelNum);

EXTERN LONG (WINAPI *cmnAiSetVoltRangeMode)	(__in LONG GlobalChNo, __in LONG RangeMode);
EXTERN LONG (WINAPI *cmnAiGetVoltRangeMode)	(__in LONG GlobalChNo, __out PLONG RangeMode);
EXTERN LONG (WINAPI *cmnAiGetDigitRange)		(__in LONG GlobalChNo, __out PLONG DigitMin, __out PLONG DigitMax);

EXTERN LONG (WINAPI *cmnAiGetDigit)	(__in LONG GlobalChNo,  __out PLONG nDigit);
EXTERN LONG (WINAPI *cmnAiGetVolt)		(__in LONG GlobalChNo,  __out DOUBLE *fVolt);
EXTERN LONG (WINAPI *cmnAiGetCurrent)	(__in LONG GlobalChNo,  __out DOUBLE *fCurrent);

EXTERN LONG (WINAPI *cmnAoSetDigit)	(__in LONG GlobalChNo,  __in  LONG  nDigit);
EXTERN LONG (WINAPI *cmnAoSetVolt)		(__in LONG GlobalChNo,  __in  DOUBLE  fVolt);
EXTERN LONG (WINAPI *cmnAoSetCurrent)	(__in LONG GlobalChNo,  __in  DOUBLE  fCurrent);

EXTERN LONG (WINAPI *cmnGnSlaveConfig)	(__in LONG NumSlave,  __in  TCNETInitData *  SlaveData);

//////////////////////////////////////////////////////////////////////////
// C-NET Serial Functions  (SLAVE)
//////////////////////////////////////////////////////////////////////////

EXTERN LONG (WINAPI *cmnGnGetSerTotal)			(__out PLONG pTotalSerChannelNum);
EXTERN LONG (WINAPI *cmnSerOpenPort)			(__in LONG GlobalChNo, __in LONG nSerialType, __in LONG nBaudRate, __in LONG nDataBits, __in LONG nStopBits, __in LONG nParity);
EXTERN LONG (WINAPI *cmnSerClosePort)			(__in LONG GlobalChNo);
EXTERN LONG (WINAPI *cmnSerSetTimeout)			(__in LONG GlobalChNo, __in LONG nTimeOut);
EXTERN LONG (WINAPI *cmnSerGetTimeout)			(__in LONG GlobalChNo, __out PLONG nTimeOut);
EXTERN LONG (WINAPI *cmnSerGetUnreadSize)		(__in LONG GlobalChNo, __out PLONG nUnreadSize);
EXTERN LONG (WINAPI *cmnSerIsDataReady)			(__in LONG GlobalChNo, __out PLONG IsReady);
EXTERN LONG (WINAPI *cmnSerReadBytes)			(__in LONG GlobalChNo, __in LONG nLength, __out PCHAR pBuffer);
EXTERN LONG (WINAPI *cmnSerWriteBytes)			(__in LONG GlobalChNo, __in LONG nLength, __in PCHAR pBuffer);
EXTERN LONG (WINAPI *cmnSerRxReset)				(__in LONG GlobalChNo);
EXTERN LONG (WINAPI *cmnSerTxReset)				(__in LONG GlobalChNo);

//////////////////////////////////////////////////////////////////////////
// C-NET Motion Functions  (SLAVE)
//////////////////////////////////////////////////////////////////////////

EXTERN LONG (WINAPI *cmnGnGetMotionTotal)		(__out PLONG pTotalMotionChannelNum);
EXTERN LONG (WINAPI *cmnGnSetServoOn)			(__in LONG GlobalAxisNo, __in LONG Enable);
EXTERN LONG (WINAPI *cmnGnGetServoOn)				(__in LONG GlobalAxisNo, __out PLONG Enable);
EXTERN LONG (WINAPI *cmnGnPulseAlarmRes)			(__in LONG GlobalAxisNo, __in LONG IsOnPulse, __in LONG dwDuration);
EXTERN LONG (WINAPI *cmnGnSetAlarmRes)				(__in LONG GlobalAxisNo, __in LONG Enable);
EXTERN LONG (WINAPI *cmnGnGetAlarmRes)				(__in LONG GlobalAxisNo, __out PLONG Enable);
EXTERN LONG (WINAPI *cmnCfgSetMioProperty)			(__in LONG GlobalAxisNo, __in LONG PropId, __in LONG ProVal);
EXTERN LONG (WINAPI *cmnCfgGetMioProperty)			(__in LONG GlobalAxisNo, __in LONG PropId, __out PLONG ProVal);
EXTERN LONG (WINAPI *cmnCfgSetInMode)				(__in LONG GlobalAxisNo, __in LONG InputMode, __in LONG IsInverse);
EXTERN LONG (WINAPI *cmnCfgGetInMode)				(__in LONG GlobalAxisNo, __out PLONG InputMode, __out PLONG IsInverse);
EXTERN LONG (WINAPI *cmnCfgSetOutMode)				(__in LONG GlobalAxisNo, __in LONG OutputMode);
EXTERN LONG (WINAPI *cmnCfgGetOutMode)				(__in LONG GlobalAxisNo, __out PLONG OutputMode);
EXTERN LONG (WINAPI *cmnCfgSetInOutRatio)			(__in LONG GlobalAxisNo, __in DOUBLE Ratio);
EXTERN LONG (WINAPI *cmnCfgGetInOutRatio)			(__in LONG GlobalAxisNo, __out DOUBLE* Ratio);
EXTERN LONG (WINAPI *cmnCfgSetUnitDist)				(__in LONG GlobalAxisNo, __in DOUBLE UnitDist);
EXTERN LONG (WINAPI *cmnCfgGetUnitDist)				(__in LONG GlobalAxisNo, __out DOUBLE* UnitDist);
EXTERN LONG (WINAPI *cmnCfgSetUnitSpeed)			(__in LONG GlobalAxisNo, __in DOUBLE UnitSpeed);
EXTERN LONG (WINAPI *cmnCfgGetUnitSpeed)			(__in LONG GlobalAxisNo, __out DOUBLE* UnitSpeed);
EXTERN LONG (WINAPI *cmnCfgSetSpeedRange)			(__in LONG GlobalAxisNo, __in DOUBLE MaxPPS);
EXTERN LONG (WINAPI *cmnCfgGetSpeedRange)			(__in LONG GlobalAxisNo, __out DOUBLE* MaxPPS, __out DOUBLE* MinPPS);
EXTERN LONG (WINAPI *cmnCfgSetSpeedPattern)			(__in LONG GlobalAxisNo, __in LONG SpeedMode, __in DOUBLE WorkSpeed, __in DOUBLE Accel, __in DOUBLE Decel);
EXTERN LONG (WINAPI *cmnCfgGetSpeedPattern)			(__in LONG GlobalAxisNo, __out PLONG SpeedMode, __out DOUBLE* WorkSpeed, __out DOUBLE* Accel, __out DOUBLE* Decel);
EXTERN LONG (WINAPI *cmnCfgSetSpeedPattern_T)		(__in LONG GlobalAxisNo, __in LONG SpeedMode, __in DOUBLE WorkSpeed, __in DOUBLE AccelTime, __in DOUBLE DecelTime);
EXTERN LONG (WINAPI *cmnCfgGetSpeedPattern_T)		(__in LONG GlobalAxisNo, __out PLONG SpeedMode, __out DOUBLE* WorkSpeed, __out DOUBLE* AccelTime, __out DOUBLE* DecelTime);
EXTERN LONG (WINAPI *cmnCfgSetMinAccTime)			(__in LONG GlobalAxisNo, __in DOUBLE MinAccT, __in DOUBLE MinDecT);
EXTERN LONG (WINAPI *cmnCfgGetMinAccTime)			(__in LONG GlobalAxisNo, __out DOUBLE* MinAccT, __out DOUBLE* MinDecT);
EXTERN LONG (WINAPI *cmnCfgSetSoftLimit)			(__in LONG GlobalAxisNo, __in LONG Enable, __in DOUBLE LimitN, __in DOUBLE LimitP);
EXTERN LONG (WINAPI *cmnCfgGetSoftLimit)			(__in LONG GlobalAxisNo, __out PLONG Enable, __out DOUBLE* LimitN, __out DOUBLE* LimitP);
EXTERN LONG (WINAPI *cmnCfgSetRingCntr)				(__in LONG GlobalAxisNo, __in LONG TargCntr, __in LONG Enable, __in DOUBLE CntMax);
EXTERN LONG (WINAPI *cmnCfgGetRingCntr)				(__in LONG GlobalAxisNo, __in LONG TargCntr, __out PLONG Enable, __out DOUBLE* CntMax);
EXTERN LONG (WINAPI *cmnCfgSetVelCorrRatio)			(__in LONG GlobalAxisNo, __in DOUBLE CorrRatio);
EXTERN LONG (WINAPI *cmnCfgGetVelCorrRatio)			(__in LONG GlobalAxisNo, __out DOUBLE* CorrRatio);
EXTERN LONG (WINAPI *cmnSxSetSpeedRatio)			(__in LONG GlobalAxisNo, __in LONG SpeedMode, __in DOUBLE VelRatio, __in DOUBLE AccRatio, __in DOUBLE DecRatio);
EXTERN LONG (WINAPI *cmnSxGetSpeedRatio)			(__in LONG GlobalAxisNo, __out PLONG SpeedMode, __out DOUBLE* VelRatio, __out DOUBLE* AccRatio, __out DOUBLE* DecRatio);
EXTERN LONG (WINAPI *cmnSxMove)						(__in LONG GlobalAxisNo, __in DOUBLE Distance, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnSxMoveStart)				(__in LONG GlobalAxisNo, __in DOUBLE Distance);
EXTERN LONG (WINAPI *cmnSxMoveTo)					(__in LONG GlobalAxisNo, __in DOUBLE Position, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnSxMoveToStart)				(__in LONG GlobalAxisNo, __in DOUBLE Position);
EXTERN LONG (WINAPI *cmnSxVMoveStart)				(__in LONG GlobalAxisNo, __in LONG Dir);
EXTERN LONG (WINAPI *cmnSxStop)						(__in LONG GlobalAxisNo, __in LONG IsWaitComplete, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnSxStopEmg)					(__in LONG GlobalAxisNo);
EXTERN LONG (WINAPI *cmnSxIsDone)					(__in LONG GlobalAxisNo, __out PLONG IsDone);
EXTERN LONG (WINAPI *cmnSxWaitDone)					(__in LONG GlobalAxisNo, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnSxOptSetIniSpeed)			(__in LONG GlobalAxisNo, __in DOUBLE IniSpeed);
EXTERN LONG (WINAPI *cmnSxOptGetIniSpeed)			(__in LONG GlobalAxisNo, __out DOUBLE* IniSpeed);
EXTERN LONG (WINAPI *cmnSxSetCorrection)			(__in LONG GlobalAxisNo, __in LONG CorrMode, __in DOUBLE CorrAmount, __in DOUBLE CorrVel, __in LONG CntrMask);
EXTERN LONG (WINAPI *cmnSxGetCorrection)			(__in LONG GlobalAxisNo, __out PLONG CorrMode, __out DOUBLE* CorrAmount, __out DOUBLE* CorrVel, __out PLONG CntrMask);
EXTERN LONG (WINAPI *cmnSxOptSetRdpOffset)			(__in LONG GlobalAxisNo, __in DOUBLE OffsetDist);
EXTERN LONG (WINAPI *cmnSxOptGetRdpOffset)			(__in LONG GlobalAxisNo, __out DOUBLE* OffsetDist);
EXTERN LONG (WINAPI *cmnStSetCount)					(__in LONG GlobalAxisNo, __in LONG Target, __in LONG Count);
EXTERN LONG (WINAPI *cmnStGetCount)					(__in LONG GlobalAxisNo, __in LONG Target, __out PLONG Count);
EXTERN LONG (WINAPI *cmnStGetSpeed)					(__in LONG GlobalAxisNo, __in LONG Source, __out DOUBLE* Speed);
EXTERN LONG (WINAPI *cmnStReadMotionState)			(__in LONG GlobalAxisNo, __out PLONG MotStates);
EXTERN LONG (WINAPI *cmnStReadMioState)				(__in LONG GlobalAxisNo, __out PLONG MioStates);
EXTERN LONG (WINAPI *cmnHomeSetConfig)				(__in LONG GlobalAxisNo, __in LONG HomeMode, __in LONG EzCount, __in DOUBLE EscDist, __in DOUBLE Offset);
EXTERN LONG (WINAPI *cmnHomeGetConfig)				(__in LONG GlobalAxisNo, __out PLONG HomeMode, __out PLONG EzCount, __out DOUBLE* EscDist, __out DOUBLE* Offset);
EXTERN LONG (WINAPI *cmnHomeSetPosClrMode)			(__in LONG GlobalAxisNo, __in LONG PosClrMode);
EXTERN LONG (WINAPI *cmnHomeGetPosClrMode)			(__in LONG GlobalAxisNo, __out PLONG PosClrMode);
EXTERN LONG (WINAPI *cmnHomeSetSpeedPattern)		(__in LONG GlobalAxisNo, __in LONG SpeedMode, __in DOUBLE Vel, __in DOUBLE Accel, __in DOUBLE Decel, __in DOUBLE RevVel);
EXTERN LONG (WINAPI *cmnHomeGetSpeedPattern)		(__in LONG GlobalAxisNo, __out PLONG SpeedMode, __out DOUBLE* Vel, __out DOUBLE* Accel, __out DOUBLE* Decel, __out DOUBLE* RevVel);
EXTERN LONG (WINAPI *cmnHomeSetSpeedPattern_T)		(__in LONG GlobalAxisNo, __in LONG SpeedMode, __in DOUBLE Vel, __in DOUBLE AccelTime, __in DOUBLE DecelTime, __in DOUBLE RevVel);
EXTERN LONG (WINAPI *cmnHomeGetSpeedPattern_T)		(__in LONG GlobalAxisNo, __out PLONG SpeedMode, __out DOUBLE* Vel, __out DOUBLE* AccelTime, __out DOUBLE* DecelTime, __out DOUBLE* RevVel);
EXTERN LONG (WINAPI *cmnHomeMoveStart)				(__in LONG GlobalAxisNo, __in LONG Direction);
EXTERN LONG (WINAPI *cmnHomeMove)					(__in LONG GlobalAxisNo, __in LONG Direction, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnHomeMoveAll)				(__in LONG NumAxes, __out PLONG AxisList, __out PLONG DirList, __in LONG IsBlocking);
EXTERN LONG (WINAPI *cmnHomeMoveAllStart)			(__in LONG NumAxes, __out PLONG AxisList, __out PLONG DirList);
EXTERN LONG (WINAPI *cmnHomeGetSuccess)				(__in LONG GlobalAxisNo, __in LONG *IsSuccess);
EXTERN LONG (WINAPI *cmnHomeSetSuccess)				(__in LONG GlobalAxisNo, __in LONG IsSuccess);
EXTERN LONG (WINAPI *cmnHomeIsBusy)					(__in LONG GlobalAxisNo, __in LONG *IsBusy);
EXTERN LONG (WINAPI *cmnHomeWaitDone)				(__in LONG GlobalAxisNo, __in LONG IsBlocking);

#ifdef __cplusplus
}
#endif


#endif
