' --------------------------------------------------------------
'            Copyright (C) 2000-2008 COMIZOA Co., LTD.          
' --------------------------------------------------------------

Option Explicit On

' DATE	: 2009-02-23
' TIME	: 16:04:55
Imports System
Imports System.Runtime.InteropServices

Namespace Shared2

    Public Class CNetDll
        '******************************************************************************
        '* [ ComiNETSDKDef.h ]
        '* Header file for definitions of constants and data in CMNSDK library
        '* - Update Data: 2007/04/23
        '* - Provider: COMIZOA Co., Ltd.
        '* - Phone: +82-42-936-6500~6
        '* - Fax  : +82-42-936-6507
        '* - URL  : http://www.comizoa.co.kr,  http://www.comizoa.com
        '*******************************************************************************

        '*******************************************************************************
        Public Const VERSION_STRING_LENGTH As Int32 = 21 + 1
        Public Const VERSION_STRING As String = "C-NET Library 3.0"

        '//////////////////////////////////////////////////////////////////////
        Public Const cmnERR_NONE As Int32 = 0
        Public Const cmnERR_INVALID_PARAMETER As Int32 = -190
        Public Const cmnERR_MEM_ALLOC_FAIL As Int32 = -290
        Public Const cmnERR_GLOBAL_MEM_FAIL As Int32 = -292

        '//////////////////////////////////////////////////////////////////////
        Public Const cmnTRUE As Int32 = 1
        Public Const cmnFALSE As Int32 = 0

        '//////////////////////////////////////////////////////////////////////
        Public Const cmnERR_GN_RELOAD_DEVICE_FAIL As Int32 = -9000
        Public Const cmnERR_GN_LOAD_DEVICE_FAIL As Int32 = -10000
        Public Const cmnERR_GN_UNLOAD_DEVICE_FAIL As Int32 = -10001
        Public Const cmnERR_GET_SLAVE_INFO_FAIL As Int32 = -10002
        Public Const cmnERR_GET_SLAVE_INFO_ALL_FAIL As Int32 = -10003
        Public Const cmnERR_GET_GLOBAL_CHANNEL_MAP_FAIL As Int32 = -10004
        Public Const cmnERR_GN_GET_GLOBAL_CHANNEL_MAP_FAIL As Int32 = -10005
        Public Const cmnERR_GN_PUT_USER_CHANNEL_MAP_FAIL As Int32 = -10006
        Public Const cmnERR_GN_DLG_SETUP_FAIL As Int32 = -10007
        Public Const cmnERR_LOCAL_DI_GET_ONE_FAIL As Int32 = -10008
        Public Const cmnERR_LOCAL_DI_GET_MULTI_FAIL As Int32 = -10009
        Public Const cmnERR_LOCAL_DO_PUT_ONE_FAIL As Int32 = -10010
        Public Const cmnERR_LOCAL_DO_PUT_MULTI_FAIL As Int32 = -10011
        Public Const cmnERR_LOCAL_DO_GET_ONE_FAIL As Int32 = -10012
        Public Const cmnERR_LOCAL_DO_GET_MULTI_FAIL As Int32 = -10013
        Public Const cmnERR_DI_GET_ONE_FAIL As Int32 = -10014
        Public Const cmnERR_DI_GET_MULTI_FAIL As Int32 = -10015
        Public Const cmnERR_DO_PUT_ONE_FAIL As Int32 = -10016
        Public Const cmnERR_DO_PUT_MULTI_FAIL As Int32 = -10017
        Public Const cmnERR_DO_GET_ONE_FAIL As Int32 = -10018
        Public Const cmnERR_DO_GET_MULTI_FAIL As Int32 = -10019
        Public Const cmnERR_GN_START_RING_ALL_FAIL As Int32 = -10020
        Public Const cmnERR_GN_START_RING_FAIL As Int32 = -10021
        Public Const cmnERR_GN_RESET_RING_FAIL As Int32 = -10022
        Public Const cmnERR_GN_STOP_RING_FAIL As Int32 = -10023
        Public Const cmnERR_GN_RESET_DEVICE_FAIL As Int32 = -10024
        Public Const cmnERR_GN_ISRESET_DEVICE_FAIL As Int32 = -10025
        Public Const cmnERR_GN_GET_COM_STATUS_FAIL As Int32 = -10026
        Public Const cmmERR_GN_GET_COM_SPEED_FAIL As Int32 = -10027
        Public Const cmnERR_GN_SET_COM_SPEED As Int32 = -10028
        Public Const cmnERR_GN_DLG_GET_LAST_MESSAGE_FAIL As Int32 = -10029
        Public Const cmnERR_GN_DLG_GET_NO_MORE_MESSAGE_FAIL As Int32 = -10030
        Public Const cmnERR_GN_DLG_GET_BUFFER_SMALL_FAIL As Int32 = -10031

        '//////////////////////////////////////////////////////////////////////
        Public Const cmnLOGIC_A As Int32 = 0
        Public Const cmnLOGIC_B As Int32 = 1

        '//////////////////////////////////////////////////////////////////////

        ' Device Information

        '//////////////////////////////////////////////////////////////////////
        Public Const DI_00_DO_32C As Int32 = &H0
        Public Const DI_08_DO_08C As Int32 = &H1
        Public Const DI_16_DO_16C As Int32 = &H2
        Public Const DI_16_DO_OOH As Int32 = &H3
        Public Const DI_32_DO_00C As Int32 = &H4
        Public Const DI_08_DO_08H As Int32 = DI_08_DO_08C
        Public Const DI_00_DO_16H As Int32 = &H5

        '//////////////////////////////////////////////////////////////////////

        ' Communication Speed

        '//////////////////////////////////////////////////////////////////////
        Public Const SPEED_1X As Int32 = &H0
        ' 2.5 Mbps 
        Public Const SPEED_2X As Int32 = &H1
        ' 5 Mbps 
        Public Const SPEED_3X As Int32 = &H2
        ' 10Mbps 
        Public Const SPEED_4X As Int32 = &H3
        ' 20Mbps 

        '//////////////////////////////////////////////////////////////////////

        ' Communication Status

        '//////////////////////////////////////////////////////////////////////
        Public Const RING_DISCONNECTED As Int32 = 13
        Public Const RING_CONNECTED As Int32 = 12
        Public Const SLAVE_ERROR As Int32 = 3
        Public Const RING_STOP As Int32 = 2

        '//////////////////////////////////////////////////////////////////////

        ' Debugging

        '//////////////////////////////////////////////////////////////////////
        Public Const DEBUG_LEVEL_SUMMERY As Int32 = 0
        Public Const DEBUG_LEVEL_DETAIL As Int32 = 1
        Public Const DEBUG_LEVEL_DEBUG As Int32 = 2
        Public Const DEBUG_LEVEL_ALL As Int32 = 3
        Public Const DEBUG_DISABLE As Int32 = 0
        Public Const DEBUG_ENABLE As Int32 = 1
        Public Const DEBUG_OUT_WINDOW As Int32 = 0
        Public Const DEBUG_OUT_LOCALFILE As Int32 = 1
        Public Const DEBUG_OUT_CONSOLE As Int32 = 2
        Public Const DEBUG_OUT_SOCKET As Int32 = 3
        Public Const DEBUG_OUT_CALLBACK As Int32 = 4

        '//////////////////////////////////////////////////////////////////////

        '  Master ġ  

        '//////////////////////////////////////////////////////////////////////
        Public Const MAX_SLAVE As Int32 = 64
        Public Const MAX_RING As Int32 = 2

        ''////////////////////////////////////////////////////////////////////
        ' Device Load / Unload
        ''////////////////////////////////////////////////////////////////////

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnLoadDevice", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnLoadDevice _
        (ByVal IsResetDevice As Integer, ByRef nTotalMasterDevices As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnReloadDevice", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnReloadDevice _
        (ByVal IsResetDevice As Integer, ByRef nTotalMasterDevices As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnCtrlBoost", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnCtrlBoost _
        (ByVal IsEnable As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Basic Control
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnIsResetDevice", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnIsResetDevice _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef IsReset As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnResetDevice", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnResetDevice _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnSetSearchSpeicalDelay", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnSetSearchSpeicalDelay _
        (ByVal nDeviceNo As Integer, ByVal nDelay_us As Integer) _
        As Integer

        End Function


        ''////////////////////////////////////////////////////////////////////
        ' Debug Function
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnDlgSetup", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnDlgSetup _
        (ByVal Enable As Boolean, ByVal nLevel As Double, ByVal nDebugType As Double, ByVal Handler As Integer, ByVal lParam As Object, ByRef szDebugFileName As String) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnDlgGetLastMessage", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnDlgGetLastMessage _
        (ByVal nBufferSize As Integer, ByRef szBuffer As String, ByRef StoredMsg As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' C-NET Communcation internal  (MASTER)
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDiSetInputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDiSetInputLogic _
        (ByVal GlobalChNo As Integer, ByVal InputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDiGetInputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDiGetInputLogic _
        (ByVal GlobalChNo As Integer, ByRef InputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoSetOutputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoSetOutputLogic _
        (ByVal GlobalChNo As Integer, ByVal OutputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoGetOutputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoGetOutputLogic _
        (ByVal GlobalChNo As Integer, ByRef OutputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDiGetOne", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDiGetOne _
        (ByVal GlobalChNo As Integer, ByRef InputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDiGetMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDiGetMulti _
        (ByVal IniChannel As Integer, ByVal NumChannel As Integer, ByRef InuptStates As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoPutOne", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoPutOne _
        (ByVal GlobalChNo As Integer, ByVal OutState As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoPutMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoPutMulti _
        (ByVal IniChannel As Integer, ByVal NumChannel As Integer, ByVal OutStates As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoPutMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoGetOne _
        (ByVal GlobalChNo As Integer, ByRef OutputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnLocalDoPutMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnLocalDoGetMulti _
        (ByVal IniChannel As Integer, ByVal NumChannel As Integer, ByRef OutStates As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' C-NET Communication between slave and master  (SLAVE)
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiSetInputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiSetInputLogic _
        (ByVal GlobalChNo As Integer, ByVal InputLogic As Integer) _
        As Integer

        End Function
        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiGetInputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiGetInputLogic _
        (ByVal GlobalChNo As Integer, ByRef InputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoSetOutputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoSetOutputLogic _
        (ByVal GlobalChNo As Integer, ByVal OutputLogic As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoGetOutputLogic", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoGetOutputLogic _
        (ByVal GlobalChNo As Integer, ByRef OutputLogic As Integer) _
        As Integer

        End Function


        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiGetOne", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiGetOne _
        (ByVal GlobalChNo As Integer, ByRef InputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiGetMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiGetMulti _
        (ByVal IniChannel As Integer, ByVal nChannels As Integer, ByRef InputStates As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoPutOne", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoPutOne _
        (ByVal GlobalChNo As Integer, ByVal OutState As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoPutMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoPutMulti _
        (ByVal IniChannel As Integer, ByVal nChannels As Integer, ByVal OutStates As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoGetOne", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoGetOne _
        (ByVal GlobalChNo As Integer, ByRef OutputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoGetMulti", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoGetMulti _
        (ByVal IniChannel As Integer, ByVal nChannels As Integer, ByRef OutStates As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' C-NET Communication between slave and master  (SLAVE) (EX Functions)
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiGetOneEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiGetOneEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByVal nChannelNo As Integer, ByRef InputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDiGetMultiEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDiGetMultiEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByRef InputStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoPutOneEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoPutOneEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByVal nChannel As Integer, ByVal OutState As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoPutMultiEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoPutMultiEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByVal OutStates As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoGetOneEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoGetOneEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByVal nChannelNo As Integer, ByRef OutState As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnDoGetMultiEx", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnDoGetMultiEx _
        (ByVal nMasterCardNo As Integer, ByVal nRingNo As Integer, ByVal nDevIp As Integer, ByVal nPortNo As Integer, ByRef OutStates As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Communication Control
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnStartRingAll", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnStartRingAll _
        () _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnStartRing", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnStartRing _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByVal nSlaveIp As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnResetRing", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnResetRing _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnStopRing", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnStopRing _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetComStatus", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetComStatus _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef nStatus As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Communication Speed Control
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetComSpeed", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetComSpeed _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef pStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnSetComSpeed", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnSetComSpeed _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByVal nStatus As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' General Device Information Functions
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetMasterTotal", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetMasterTotal _
        (ByRef pTotalDeviceNum As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetSlaveTotal", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetSlaveTotal _
        (ByRef pTotalDeviceNum As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetDITotal", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetDITotal _
        (ByRef pTotalDiChannelNum As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetDOTotal", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetDOTotal _
        (ByRef pTotalDOChannelNum As Integer) _
        As Integer

        End Function

        ' ش ̽    ȯѴ.
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetRingTotal", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetRingTotal _
        (ByVal nDeviceNo As Integer, ByRef pRingTotal As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Master Device Information Functions
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetMasterInfo", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetMasterInfo _
        (ByVal nDeviceNo As Integer, ByRef pDeviceId As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Slave Device Information Functions
        ''////////////////////////////////////////////////////////////////////
        '<DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetSlaveInfoAll", SetLastError:=True, _
        'CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        'Public Shared Function cmnGnGetSlaveInfoAll _
        '(ByVal nDeviceNo As Integer, ByRef pDevInfo As TCMNDevInfo, ByRef pRing0SlaveTotal As Integer, ByRef pRing1SlaveTotal As Integer) _
        'As Integer

        'End Function


        ''////////////////////////////////////////////////////////////////////
        ' Set/Get of Error Communication Slave Device Number
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetSlaveComError", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetSlaveComError _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef pStatus1 As Integer, ByRef pStatus2 As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnClrSlaveComError", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnClrSlaveComError _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByVal nStatus1 As Integer, ByVal nStatus2 As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' Interrupt Functions
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetMasterInterruptStatus", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetMasterInterruptStatus _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef pStatus As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnSetInputInterruptEnable", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnSetInputInterruptEnable _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef pStatus1 As Integer, ByRef pStatus2 As Integer) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetInputInterruptStatus", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetInputInterruptStatus _
        (ByVal nDeviceNo As Integer, ByVal nRingNo As Integer, ByRef pStatus1 As Integer, ByRef pStatus2 As Integer) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
        ' User Mapped Channel And Global Channel
        ''////////////////////////////////////////////////////////////////////
        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnGetGlobalChannelMap", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnGetGlobalChannelMap _
        (ByRef szFileName As String) _
        As Integer

        End Function

        <DllImport("CNETSDK.dll", EntryPoint:="cmnGnPutUserChannelMap", SetLastError:=True, _
        CharSet:=CharSet.Ansi, ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
        Public Shared Function cmnGnPutUserChannelMap _
        (ByRef szFileName As String) _
        As Integer

        End Function

        ''////////////////////////////////////////////////////////////////////
    End Class
End Namespace